> For the complete documentation index, see [llms.txt](https://docs.payments.thalescloud.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.payments.thalescloud.io/nfc-wallet-sdk-ios/implement-nfc-wallet/make-payments/understand-cdcvm/device-unlock-method-update-scenarios.md).

# Device unlock method update scenarios

### Overview

This page explains how changes to the device unlock method affect CDCVM behavior.

The behavior depends on the CDCVM policy configured during NFC Wallet SDK initialization:

* `.biometricOnly`
* `.userPresence`

For setup details, see [NFC Wallet SDK initialization](/nfc-wallet-sdk-ios/get-started/configuration/3.-initialization.md#cardholder-verification-method) and [Understand CDCVM](/nfc-wallet-sdk-ios/implement-nfc-wallet/make-payments/understand-cdcvm.md).

### Scenarios

#### Scenarios for biometrics only (`.biometricOnly`)

<table data-full-width="true"><thead><tr><th>Device state change</th><th>iOS</th><th>NFC Wallet SDK</th><th>Digital wallet application</th></tr></thead><tbody><tr><td>End user disables the device lock screen. For example, biometrics are not enrolled and passcode is turned off.</td><td>Invalidates the key material in the keychain.</td><td>Detects that the key material is invalid when accessing the keychain.</td><td>Wipes local data and throws <code>ContactlessPaymentSession.Error.authenticationKeyInvalidated(error)</code>. Reinitialize the SDK. See <a href="/pages/aaZvcD4kfwI0oUryoCdX#tsh-pay-sdk-initialisation">NFC Wallet SDK initialization</a>.</td></tr><tr><td>End user disables the passcode, then re-enables it and re-enrolls biometrics.</td><td>Invalidates the key material in the keychain.</td><td>Detects that the key material is invalid when accessing the keychain.</td><td>Wipes local data and throws <code>ContactlessPaymentSession.Error.authenticationKeyInvalidated(error)</code>. Reinitialize the SDK. See <a href="/pages/aaZvcD4kfwI0oUryoCdX#tsh-pay-sdk-initialisation">NFC Wallet SDK initialization</a>.</td></tr><tr><td>End user changes the passcode while biometrics remain enrolled.</td><td>No action.</td><td>No action.</td><td>No action.</td></tr><tr><td>End user keeps a passcode but removes all biometrics.</td><td>No action.</td><td>Detects that biometrics were removed.</td><td>Throws <code>ContactlessPaymentSession.Error.biometricNotEnrolled</code>.</td></tr><tr><td>End user keeps a passcode and enrolls new biometrics.</td><td>No action.</td><td>No action.</td><td>No action.</td></tr></tbody></table>

#### Scenarios for user presence (`.userPresence`)

<table data-full-width="true"><thead><tr><th>Device state change</th><th>iOS</th><th>NFC Wallet SDK</th><th>Digital wallet application</th></tr></thead><tbody><tr><td>End user disables the device lock screen. For example, biometrics are not enrolled and passcode is turned off.</td><td>Invalidates the key material in the keychain.</td><td>Detects that the key material is invalid when accessing the keychain.</td><td>Wipes local data and throws <code>ContactlessPaymentSession.Error.authenticationKeyInvalidated(error)</code>. Reinitialize the SDK. See <a href="/pages/aaZvcD4kfwI0oUryoCdX#tsh-pay-sdk-initialisation">NFC Wallet SDK initialization</a>.</td></tr><tr><td>End user disables the passcode, then enables it again and enrolls biometrics again.</td><td>Invalidates the key material in the keychain.</td><td>Detects that the key material is invalid when accessing the keychain.</td><td>Wipes local data and throws <code>ContactlessPaymentSession.Error.authenticationKeyInvalidated(error)</code>. Reinitialize the SDK. See <a href="/pages/aaZvcD4kfwI0oUryoCdX#tsh-pay-sdk-initialisation">NFC Wallet SDK initialization</a>.</td></tr><tr><td>End user changes the passcode while biometrics remain enrolled.</td><td>No action.</td><td>No action.</td><td>No action.</td></tr><tr><td>End user changes the passcode when no biometrics are enrolled.</td><td>No action.</td><td>No action.</td><td>No action.</td></tr><tr><td>End user keeps a passcode but removes all biometrics.</td><td>No action.</td><td>No action.</td><td>No action.</td></tr><tr><td>End user keeps a passcode and enrolls new biometrics.</td><td>No action.</td><td>No action.</td><td>No action.</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.payments.thalescloud.io/nfc-wallet-sdk-ios/implement-nfc-wallet/make-payments/understand-cdcvm/device-unlock-method-update-scenarios.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
